-- Single-Port RAM with Asynchronous Read (Distributed RAM)
-- File: rams_dist.vhd

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity rams_dist is
    generic(
        W   : integer := 16;
        addr_W: integer := 10;
        addr_S: integer := 1024
    );
	port(
		clk : in  std_logic;
		we  : in  std_logic;
		a   : in  std_logic_vector(addr_W-1 downto 0);
		di  : in  std_logic_vector(W-1 downto 0);
		do  : out std_logic_vector(W-1 downto 0)
	);
end rams_dist;

architecture syn of rams_dist is
	type ram_type is array (addr_S-1 downto 0) of std_logic_vector(W-1 downto 0);
	signal RAM : ram_type;
begin
	process(clk)
	begin
		if (clk'event and clk = '1') then
			if (we = '1') then
				RAM(conv_integer(a)) <= di;
			end if;
		end if;
	end process;

	do <= RAM(conv_integer(a));

end syn;
