-- =====================================================================
-- Copyright © 2010-2012 by Cryptographic Engineering Research Group (CERG),
-- ECE Department, George Mason University
-- Fairfax, VA, U.S.A.
-- =====================================================================

library ieee;
use ieee.std_logic_1164.all;

-- n-bits register

entity regn_v2 is
	generic (
		N : integer := 16;
		init : std_logic_vector
	);
	port (
	    clk 	: in std_logic;
	    rst     : in std_logic;
	    en 		: in std_logic;
		input  	: in std_logic_vector(N-1 downto 0);
        output 	: out std_logic_vector(N-1 downto 0)
	);
end regn_v2;

architecture pos_edge of regn_v2 is
--signal reg : std_logic_vector(N-1 downto 0);
begin
	gen : process( clk, rst )
	begin
	    if (rst = '1') then
	        output <= (others => '0');
		elsif rising_edge( clk ) then
			if ( en = '1' ) then
				output <= input;
			end if;
		end if;
	end process;
	--output <= reg;
end pos_edge;

architecture neg_edge of regn_v2 is
--signal reg : std_logic_vector(N-1 downto 0);
begin
	gen : process( clk, rst )
	begin
	    if (rst = '1') then
	        output <= (others => '0');
		elsif falling_edge( clk ) then
			if ( en = '1' ) then
				output <= input;
			end if;
		end if;
	end process;
	--output <= reg;
end neg_edge;
