-- =====================================================================
-- Copyright  2011-2012 by Cryptographic Engineering Research Group (CERG),
-- ECE Department, George Mason University
-- Fairfax, VA, U.S.A.
-- author: Marcin Rogawski
-- =====================================================================

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

-- ROM (5 input 2 output)

entity rom_5x2 is
	generic 
	( 
		ADDR_WIDTH : integer := 5;
		DATA_WIDTH : integer := 2
	);
	port 
	(
		addr  : in std_logic_vector(ADDR_WIDTH-1 downto 0);
		dout : out std_logic_vector(DATA_WIDTH-1 downto 0)
	);
end rom_5x2;

architecture arch of rom_5x2 is

	type mem is array (0 to 2**ADDR_WIDTH-1) of std_logic_vector(DATA_WIDTH-1 downto 0);

	constant rom_5x2 : mem := 
	(
		0	 => "00",	
		1	 => "01",	
		2	 => "10",	
		3	 => "00",	
		4	 => "01",	
		5	 => "10",	
		6	 => "00",	
		7	 => "01",	
		8	 => "10",	
		9	 => "00",	
		10	 => "01",	
		11	 => "10",	
		12	 => "00",	
		13	 => "01",	
		14	 => "10",	
		15	 => "00",	
		16	 => "01",	
		17	 => "10",	
		18	 => "00",	
		19	 => "01",	
		20	 => "10",	
		21	 => "00",	
		22	 => "01",	
		23	 => "10",
		24	 => "00",	
		25	 => "01",	
		26	 => "10",	
		27	 => "00",	
		28	 => "01",	
		29	 => "10",	
		30	 => "00",	
		31	 => "01"
	);

begin

	dout <= rom_5x2(conv_integer(addr));

end arch; 

































