-- =============================================================================
-- Copyright © 2017-2018 by Cryptographic Engineering Research Group (CERG),
-- ECE Department, George Mason University
-- Fairfax, VA, U.S.A.
-- Author: Farnoud Farahmand
-- =============================================================================
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;

entity vs_rom is
generic
(
	ADDR_WIDTH : integer := 4;
	DATA_WIDTH : integer := 4
);
port
(
	addr 	: in std_logic_vector(ADDR_WIDTH-1 downto 0);
	output 	: out std_logic_vector(DATA_WIDTH-1 downto 0)
);
end vs_rom;

architecture arch of vs_rom is

type mem is array (0 to 2**ADDR_WIDTH-1) of std_logic_vector(3 downto 0);

constant mod1499_rom : mem :=
(
	  0	 => x"0",
	  1	 => x"3",
	  2	 => x"6",
	  3	 => x"9",
	  4	 => x"C",
	  5	 => x"F",
	  6	 => x"2",
	  7	 => x"5",
	  8	 => x"8",
	  9	 => x"B",
	 10	 => x"E",
	 11	 => x"1",
	 12	 => x"4",
	 13	 => x"7",
	 14	 => x"A",
	 15	 => x"D"
);

 begin

 	output <= mod1499_rom(conv_integer(addr))(DATA_WIDTH-1 downto 0);

end arch;
